#!/bin/sh
#interfaz Xdialog para automatizar la colocacion manual de programas no grabados.
#Utiliza di (el uso del disco), bc (calcular espacio en disco) y
# vorbiscomment / id3v2 para meter comentarios en el archivo de audio (ogg / mp3).
# Usa Xdialog2 (compilado contra gtk2) para que en el calendario la semana empiece en lunes
#
#Este script est licenciado bajo la [1] GNU General Public License (GPL) y por tanto
# se permite su copia, distribucin y/o modificacin mientras se mantenga su licencia y
# se cite que est realizado por [2] Garraxi Irratia. Contacto: [3] Martintxo
#
#[1] http://www.gnu.org/copyleft/gpl.html
#[2] http://sindominio.net/garraxi/
#[3] martintxo@sindominio.net

#Variables utiles (paths y tal):
#DIRPROGRAMAS=/home/martintxo/pruebas
DIRPROGRAMAS=/home/garraxi/Biltegi/Programas
#CONFIGPROGRAMAS=/home/martintxo/pruebas/config-programas.txt
CONFIGPROGRAMAS=/home/garraxi/.programas-radio/config-programas.txt
#DIPATH=/
DIPATH=/home/garraxi/Biltegi/Programas

#Variable que lee los programas dados de alta desde el archivo de "configuracion":
#Lo de 'grep -v "^#"' para buscar comentarios y dar de output el resto del archivo
LISTA=`grep -v "^#" "$CONFIGPROGRAMAS" | grep -i -A 1 "SeGraba: no" - | grep -i "Nombre:" - | cut -s -d " " -f 2`
PROGRAMAS="`echo "Selecciona_nombre_programa..." && echo "$LISTA"`"

#Variable que guarda informacion sobre espacio libre en disco:
# Con df problema: segun baja el tamao disponible, cambia el output de df y cut puede no encontrar el valor
# solucion: utilizar di (pero hace honor a LANG y da decimales separados por comas, y eso no gusta a bc)
DISCO="`export LANG=en; di -f v -n -m -w 0 $DIPATH; export LANG=es_ES`"

#Con la tasa de bits a la que grabamos con flrec/sox (90 kb/s) una hora ocupa aprox 30 Mb.
#Por lo que en sdb1 (17.654Mb) pueden llegar a caber unos 580 programas de 1 hora.
#'bc' para calculo, 'expr' no decimales: http://www.webservertalk.com/archive109-2007-9-2041143.html
HORAS=$(echo "scale=1; $DISCO/30" | bc)


#Seleccionar el archivo del programa:
ARCHIVOPROGRAMA=`Xdialog2 --wmclass "grabar" --title "Selecciona archivo" \
        --backtitle "Selecciona el archivo del programa que quieres poner para su emision" \
	--stdout --left --separator "|" -no-buttons \
	 --fselect ~/ 0 0`
	 
#Para que salga si click en Cancelar, en "x" del windowmanager, o si no se pilla archivo:
STATUSRET=$?
if [ "$STATUSRET" -eq 1 ] || [ "$STATUSRET" -eq 255 ]  || [ "$ARCHIVOPROGRAMA" = "$HOME/" ];then
  exit;
fi

#Seleccionar el nombre del programa:
NOMBREPROGRAMA=`Xdialog2 --wmclass "grabar" --title "Nombre del programa" \
        --backtitle "En el disco duro donde se guardan los Programas (sdb1) quedan: $DISCO Mb libres.\nEsto equivale aproximadamente a $HORAS horas de grabacion." \
	--stdout --left --separator "|" \
	--combobox "Selecciona el nombre del programa (el asignado en la parrilla).\n * Ejemplo: Saltsa_Berde\n * El archivo se guardara en la carpeta ~/Biltegi/Programas/Emision/Nombre_programa.\n    NO LO MUEVAS DE AHI (ni le cambies el nombre).\n    Solo si esta en esa carpeta se emitara automaticamente.\nGracias :-D!!." \
0 0 $PROGRAMAS"" `

#Para que salga sin hacer nada, si se presiona Cancelar o si se pincha el boton "cerrar programa" del windowmanager:
STATUSRET=$?
if [ "$STATUSRET" -eq 1 ] || [ "$STATUSRET" -eq 255 ];then
  exit;
fi

#Cuando NO se selecciona bien la casilla, vuelve a aparecer el programa:
if [ "$NOMBREPROGRAMA" = "Selecciona_nombre_programa..." ];then
 Xdialog2 --wmclass "grabar" --title "Grabar PROGRAMAS" \
	--infobox "OOOPS!!\nParece que te has equivocado al seleccionar un nombre de programa adecuado.\nIntentalo de nuevo :-D..." 0 0 5000;
  exec coloca-programa.sh;
fi

#Seleccionar fecha de grabacion original del programa:

 #Mirar si ya hay un tag "date" y mostrarlo en xdialog (para ver tag mismo comando que jingle_reemisiones): 
 if basename "$ARCHIVOPROGRAMA" | grep -i '.ogg' > /dev/null ;then
     EXT=ogg
 elif basename "$ARCHIVOPROGRAMA" | grep -i '.mp3' > /dev/null ;then
     EXT=mp3
 else
     EXT="formato.desconocido"
 fi
 
 if [ "$EXT" = "ogg" ]; then
  FECHAORIGINAL=`vorbiscomment -l "$ARCHIVOPROGRAMA" | grep -m 1 -i "date" | cut -d "=" -f 2 -s` 
 elif [ "$EXT" = "mp3" ]; then
  FECHAORIGINAL=`id3v2 -l "$ARCHIVOPROGRAMA" | grep -m 1 -i "date" | cut -d " " -f 3 -s`
 fi
  if [ "$FECHAORIGINAL" != "" ]; then
     FECHAORIGINAL2="Los tags del archivo dicen que su fecha es: "$FECHAORIGINAL"."
  fi	

FECHAPROGRAMA=`Xdialog2 --wmclass "grabar" --title "Fecha original" \
	 --stdout --left --separator "|" -no-buttons \
	 --calendar "Selecciona la fecha en que se grabo el programa (si la conoces).\n  $FECHAORIGINAL2\nSi no la sabes dale a OK para que se quede con la fecha actual." 0 0`
	
#Para que salga sin hacer nada, si se presiona Cancelar o si se pincha el boton "cerrar programa" del windowmanager:
STATUSRET=$?
if [ "$STATUSRET" -eq 1 ] || [ "$STATUSRET" -eq 255 ];then
  exit;
fi

 DIAPROGRAMA=`echo "$FECHAPROGRAMA" | cut -d "/" -f 1 -s`
 MESPROGRAMA=`echo "$FECHAPROGRAMA" | cut -d "/" -f 2 -s`
 AOPROGRAMA=`echo "$FECHAPROGRAMA" | cut -d "/" -f 3 -s`


 ### Rutina programa anterior (similar a mantenprogramas y grabaprogramas)
 #Ver si existe algun (1 o varios) archivos de programa anterior en emision en el dir del programa:
 if  [ -d "$DIRPROGRAMAS/Emision/$NOMBREPROGRAMA" ] ;then
  # para parsear correctamente los espacios en los nombres de archivo:
  #$IFS (Input Field Separators) indica el separador utilizado, y el estandar en bash es un espacio, lo cambiamos
  OLDIFS=$IFS
  IFS=
  for PROGANT in $( find "$DIRPROGRAMAS/Emision/$NOMBREPROGRAMA" -maxdepth 1 -type f \( -iname '*.ogg' -o -iname '*.mp3' \) -printf "%p$IFS") ; do
  #Devolver el separador standar:
  IFS=$OLDIFS
  
   #SOLUCIONAR BUG soma-run que no emite el jingle definido en el palinsesto (quitar cuando bug solucionado). 
   #ver: http://lists.autistici.org/message/20080214.182240.5780d64c.en.html
   #Si archivo encontrado = 000000jingle.[mp3|ogg] => se salta el bucle (ese sera el nombre del jingle, en todos los casos):
   if [ "`basename "$PROGANT" | grep -i '000000jingle'`" ];then 
    continue  #se salta este loop for y comienza otro
   fi
   #FIN SOLUCIONAR BUG JINGLE
  
      #Si el archivo de programa anterior es reemision de programa en backup (duplicado) lo borra:
      DUPLICS=`stat -c %h "$PROGANT"`
      if [ "$DUPLICS" != "1" ];then
         rm "$PROGANT"
	 INFOANT="El programa anterior que estaba en Emision ha sido borrado,\nse trataba de un duplicado de un programa antiguo que tienes backupeado."
      else
        #Si el archivo de programa a mover NO es una reemision lo backupea:
        #Variables obtener fecha y hora del programa anterior en emision desde fecha de ultimo acceso, y su extension:
        DATEHOURANT=`stat -c %x "$PROGANT"`
          if basename "$PROGANT" | grep -i '.ogg' > /dev/null ;then
              EXTANT=ogg
          else
              EXTANT=mp3
          fi
        DATEANT=`echo "$DATEHOURANT" | cut --delimiter=" " -f 1 -s`
        HOURANT=`echo "$DATEHOURANT" | cut --delimiter=" " -f 2 -s | cut -c '-8'`
	     
          #Comprueba si hay algun archivo con ese nombre en el dir de backup, y sisi le aade un "+" hasta que deje de haber:
          while [[ -f "$DIRPROGRAMAS/Backup/$NOMBREPROGRAMA/$NOMBREPROGRAMA-$DATEANT-$HOURANT.$EXTANT" ]];do 
             HOURANT=${HOURANT}+
          done
	     
        #Backupea el archivo anterior:	     
        install -d "$DIRPROGRAMAS/Backup/$NOMBREPROGRAMA" && mv "$PROGANT" "$DIRPROGRAMAS/Backup/$NOMBREPROGRAMA/$NOMBREPROGRAMA-$DATEANT-$HOURANT.$EXTANT"
        chmod 644 "$DIRPROGRAMAS/Backup/$NOMBREPROGRAMA/$NOMBREPROGRAMA-$DATEANT-$HOURANT.$EXTANT"
        INFOANT="El programa anterior que estaba en Emision ha sido guardado en Backup,en:\n "$DIRPROGRAMAS/Backup/$NOMBREPROGRAMA/$NOMBREPROGRAMA-$DATEANT-$HOURANT.$EXTANT"."
      fi
  done
  if [ "$PROGANT" = "" ] ;then
    INFOANT="No existia un programa anterior en la carpeta de Emision de "$NOMBREPROGRAMA"."
  fi
 else
   INFOANT="Parece que es la primera vez que se trae el programa "$NOMBREPROGRAMA" a Garraxi.\n(Se ha creado la carpeta "$DIRPROGRAMAS/Emision/$NOMBREPROGRAMA")."
 fi

 ### Rutina programa nuevo:
 #Meto la fecha original de grabacion como tag:
   #Formato de fecha a meter como tags: 18/03/2008_17:23:00 (necesario para jingle-reemisiones.sh)
   FECHAPROGRAMA2="$FECHAPROGRAMA"_00:00:00
   #Meter un nuevo tag "date" (OOPS: en ogg elimina todos los tags anteriores y solo deja el nuevo date): 
   if [ "$EXT" = "ogg" ]; then
      vorbiscomment -w -t "DATE=$FECHAPROGRAMA2" "$ARCHIVOPROGRAMA"
   elif [ "$EXT" = "mp3" ]; then
      id3v2 --TDAT "$FECHAPROGRAMA2" "$ARCHIVOPROGRAMA"
   fi

 #Mueve el archivo a la carpeta adecuada (creandola si no existe) en dir Emision, y le pone el nombre del programa:   
 install -d "$DIRPROGRAMAS/Emision/$NOMBREPROGRAMA" && mv "$ARCHIVOPROGRAMA" "$DIRPROGRAMAS/Emision/$NOMBREPROGRAMA/$NOMBREPROGRAMA.$EXT"
 
 #Ajusta los permisos del archivo (quitar los de ejecucion que suele traer si viene de una particion FAT):
 chmod 644 "$DIRPROGRAMAS/Emision/$NOMBREPROGRAMA/$NOMBREPROGRAMA.$EXT"
 
 #Le pone la fecha original de grabacion en mtime y atime:
 touch -c -a -m -d "$AOPROGRAMA/$MESPROGRAMA/$DIAPROGRAMA" "$DIRPROGRAMAS/Emision/$NOMBREPROGRAMA/$NOMBREPROGRAMA.$EXT" 2>&1
 
 #GUI con la info final:
 Xdialog2 --wmclass "soma" --title "Colocar programa en emisin" --ok-label "FIN" --left  --timeout 20 \
        --msgbox "El archivo del programa que has puesto esta listo para ser emitido.\nHa quedado guardado en:\n    "$DIRPROGRAMAS/Emision/$NOMBREPROGRAMA/$NOMBREPROGRAMA.$EXT"\n \n$INFOANT\n \nRecuerda que para que tu programa se re-emita automaticamente\n   tiene que estar \"dado de alta\" en la parrilla de Somad.\n   Si no lo esta, comentalo en la asamblea, diselo a alguien de Garraxi,\n   o escribenos a garraxi@sindominio.net.\nGracias :-D!!" 0 0;

exit $?
